#!/bin/zsh
#
# Copyright (C) 2009 Nick Bowler
# Copying and distribution of this file, with or without modification,
# are permitted in any medium without royalty provided the copyright
# notice and this notice are preserved.  This file is offered as-is,
# without any warranty.
#
# Generate library dependencies for an initramfs.  Finds all dynamically linked
# binaries listed in an initramfs description (as needed by gen_init_cpio from
# the Linux source) and passes them to libs.sh in order to actually generate
# the dependencies.

if [ -z "$1" ]; then
	echo "usage: genlibs.sh initramfs-desc"
	exit 1
fi

files=(`sed -n 's/^ *file \+[^ ]\+ \+\([^ ]\+\).*/\1/p' "$1"`)

dyns=()

for i in $files; do
	if ! file "$i" | grep dynamic >/dev/null; then continue; fi
	dyns+="$i"
done

./libs.sh $dyns
